; 
;                  Build as a console mode application
; 

    .486
    .model flat, stdcall
    option casemap :none   ; case sensitive

; 

  ; --------------------------------------------------
  ; change this to 1 to display args on seperate lines
  ; --------------------------------------------------
    splitline equ 0

    include \masm32\include\windows.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\gdi32.inc
    include \masm32\macros\macros.asm
    include \masm32\include\masm32.inc

    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\masm32.lib

    source_scanner PROTO :DWORD,:DWORD,:DWORD
    create_array   PROTO :DWORD,:DWORD
    show_array     PROTO :DWORD
    detab          PROTO :DWORD

  ; --------------------------------------------------
  ; a simple debugging macro for looking at characters
  ; --------------------------------------------------
    reg MACRO register,quoted
      pushad
      pushfd
      print str$(register)
      print quoted
      print chr$(13,10)
      popfd
      popad
    ENDM

  .data
    ; ---------------------------------
    ; characters SET in following table
    ; ---------------------------------
    ;   !   logical NOT 33
    ;   "   quote       34
    ;   $   dollar      36
    ;   &   ampersand   38
    ;   '   singlequote 39
    ;   *   multiply    42
    ;   +   plus        43
    ;   -   minus       45
    ;   .   period      46
    ;   :   semicolon   58
    ;       numbers     48 to 57
    ;   <   less than   60
    ;   >   greater     62
    ;   ?   question    63
    ;   @   at symbol   64
    ;       ucase       65 to 90
    ;   [   lsquare     91
    ;   ]   rsquare     93
    ;   _   underscore  95
    ;       lcase       96 to 122
    ;   {   lcurlyb     123
    ;   |   pipe        124
    ;   }   rcurlyb     125
    ;   ~   tilde       126

    align 4
    ctable \
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0     ; 15
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0     ; 31
      db 0,1,1,0,1,0,1,1,0,0,1,1,0,1,1,0     ; 47
      db 1,1,1,1,1,1,1,1,1,1,1,0,1,0,1,1     ; 63
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1     ; 79
      db 1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,1     ; 95
      db 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1     ; 111
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0     ; 127
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0


; 

    .code

start:

    call main

    invoke ExitProcess,0

; 

main proc

    LOCAL fname :DWORD
    LOCAL pMem  :DWORD
    LOCAL pArray:DWORD
    LOCAL pMain :DWORD
    LOCAL tc    :DWORD
    LOCAL buffer[260]:BYTE

  ; -----------------------------------
  ; array has 1024 members of 128 bytes
  ; -----------------------------------
    invoke create_array,1024,128    ; create array in dynamic memory
    mov pArray, eax                 ; return address of array of pointers in EAX
    mov pMain, ecx                  ; return string memory address in ECX

    mov fname, ptr$(buffer)         ; get pointer to buffer
    invoke GetCL,1, fname           ; get 1st command line argument

    invoke exist,fname              ; check if the command line file exists
    cmp eax, 0
    je not_exist                    ; display error if not

    mov pMem, InputFile(fname)      ; load the file into memory
    invoke detab,pMem               ; convert tabs to spaces

 ;     invoke GetTickCount
 ;     mov tc, eax

    invoke source_scanner,          ; scan the source in memory
           pMem,pArray,
           OFFSET ctable

 ;     invoke GetTickCount
 ;     sub eax, tc
 ;     fn MessageBox,0,str$(eax),"MS timing",MB_OK

    jmp pexit

  not_exist:
    print chr$("Cannot find that file",13,10)
    print chr$("SYNTAX: scan5 filename.ext [ ",62," filename.txt ]",13,10)

  pexit:

    free pMem                       ; free the source memory
    free pMain                      ; free main array memory
    free pArray                     ; free array of pointers memory

    ret

main endp

; 

align 4

detab proc string:DWORD

  ; -----------------------------
  ; replace each tab with a space
  ; -----------------------------
    mov eax, string
    sub eax, 1
    jmp stlp

  align 4
  wrt:
    mov BYTE PTR [eax], 32  ; substitute a space if it is
  stlp:
    add eax, 1
    cmp BYTE PTR [eax], 9   ; is it a tab
    je wrt                  ; jump prediction is BACK
    cmp BYTE PTR [eax], 0
    jnz stlp                ; jump prediction is BACK

    ret

detab endp

; 

align 4

create_array proc acnt:DWORD,asize:DWORD

comment * -------------------------------
    acnt  = number of items in hash table
    asize = byte count for each item
    ----------------------------------- *

    LOCAL lparr:DWORD
    LOCAL lpmem:DWORD

    mov ecx, acnt
    shl ecx, 2                  ; multiply by 4
    mov lparr, alloc(ecx)       ; allocate array

    mov ecx, asize
    mov eax, acnt
    imul ecx                    ; multiply count by BYTE size for string memory length
    mov lpmem, alloc(eax)       ; allocate string memory

    mov eax, lpmem              ; string memory start address
    mov edx, lparr              ; array address
    mov ecx, acnt               ; item count
  @@:
    mov [edx], eax              ; load address in EAX into location in array
    add eax, asize              ; add "asize" for next start address
    add edx, 4                  ; set next array location
    sub ecx, 1
    jnz @B

comment * --------------------------
    deallocate both of the returned
    memory handles when the array is
    no longer required
    ------------------------------ *

    mov eax, lparr              ; return address of array of pointers in EAX
    mov ecx, lpmem              ; return string memory address in ECX

    ret

create_array endp

; 

align 4

show_array proc hArr:DWORD

    LOCAL str1  :DWORD
    LOCAL buffer1[1024]:BYTE

    push esi

    mov str1, ptr$(buffer1)

    mov esi, hArr
    mov esi, [esi]
    cmp BYTE PTR [esi], 0   ; don't display empty line
    jne @F
    pop esi
    ret

  @@:
    mov esi, hArr
    mov esi, [esi]
    cmp BYTE PTR [esi], 0
    je @F

    IF splitline
      mov str1, cat$(str1,esi,chr$(13,10))
    ELSE
      mov str1, cat$(str1,esi," ")
    ENDIF

    add hArr, 4
    jmp @B
  @@:

    mov str1, cat$(str1,chr$(13,10))
    invoke StdOut,str1

    pop esi

    ret

show_array endp

; 

source_scanner proc string:DWORD,array:DWORD,table:DWORD

    LOCAL lparr     :DWORD      ; local array variable
    LOCAL lcflag    :DWORD      ; line continuation flag
    LOCAL acnt      :DWORD      ; argument counter
    LOCAL eflag     :DWORD      ; exit flag for last statement

    push ebx
    push esi
    push edi

    mov esi, string             ; source address in ESI
    mov ebx, table              ; character table in EBX
    mov eflag, 0                ; set exit flag to zero

  reload:
    mov acnt, 0                 ; set argument counter to zero
    mov lcflag, 1
    mov eax, array              ; load array address into local variable
    mov lparr, eax
    sub lparr, 4
    xor eax, eax                ; prevent stall
    jmp jumpin                  ; jump to badchar entry point
  ; ***************************
  ; test non allowable characters
  ; ***************************
  align 4
  terminate:
    mov BYTE PTR [edi], 0       ; zero terminate arg in array member
  badchar:
  ; ---------------------------
  ; asm & C/C++ coments
  ; ---------------------------
    cmp al, ";"                 ; assembler comment
    je decomment
    cmp al, "/"                 ; C and C++ comment
    je deCcomment
  ; ---------------------------
    cmp al, "\"                 ; test for line continuation
    jne @F
    mov lcflag, 1               ; set line continuation flag
  @@:
    cmp al, ","                 ; test for line continuation
    jne @F
    mov lcflag, 1               ; set line continuation flag
  @@:
    cmp al, 10                  ; test end of line condition
    jne @F
    cmp lcflag, 0               ; if flag is clear with ascii
    je setend                   ; 10 as last char, no further
  @@:                           ; args in source statement
  ; ---------------------------
  ; this is the extry point
  ; for the next character.
  ; ---------------------------
  jumpin:
    mov al, [esi]
    add esi, 1
    test al, al
    je setexit
    cmp BYTE PTR [ebx+eax], 0   ; is char in table ?
    je badchar
  ; ===========================
  arrnext:
    add lparr, 4                ; set array to next member
    mov edi, lparr              ; load its address in EDI
    mov edi, [edi]              ; dereference it to get start address
    add acnt, 1                 ; increment argument counter
    mov lcflag, 0               ; clear line continuation flag
    sub esi, 1
  ; ---------------------------
    cmp al, 34                  ; process double quoted text
    je quotes
    cmp al, 39                  ; process single quoted text
    je squotes
    cmp al, "["                 ; process code in square brackets
    je squareb
  ; ---------------------------
    jmp goodchar
  ; ***************************
  ; write allowable characters
  ; ***************************
  align 4
  goodchar:
    mov al, [esi]
    add esi, 1
    cmp BYTE PTR [ebx+eax], 0   ; is char in table ?
    je terminate
  writeit:
    mov [edi], al
    add edi, 1
    jmp goodchar
  ; ***************************
  ; process quoted text and
  ; code in square brackets
  ; ***************************
  align 4
  squotes:
    add esi, 1
    mov [edi], al
    add edi, 1
  @@:
    mov al, [esi]
    add esi, 1
    cmp al, 10                  ; ascii 0 or line end without [ ' ] error
    jle zero
    mov [edi], al
    add edi, 1
    cmp al, 39
    jne @B
    jmp terminate
  ; ***************************
  align 4
  quotes:
    add esi, 1
    mov [edi], al
    add edi, 1
  @@:
    mov al, [esi]
    add esi, 1
    cmp al, 10                  ; ascii 0 or line end without [ " ] error
    jle zero
    mov [edi], al
    add edi, 1
    cmp al, 34
    jne @B
    jmp terminate
  ; ***************************
  align 4
  squareb:
    mov al, [esi]
    add esi, 1
    cmp al, 10                  ; ascii 0 or line end without ] error
    jle zero
    mov [edi], al
    add edi, 1
    cmp al, "]"
    jne squareb
    jmp terminate
  ; ***************************
  ; process comments
  ; ***************************
  align 4
  setexit:
    mov eflag, 1                ; set exit flag
    jmp setend
  ; ===========================
  align 4
  decomment:                    ; asm or C++ comment
    mov al, [esi]
    add esi, 1
    test al, al                 ; exit on EOF condition
    je setexit
    cmp al, 10                  ; loop until end of line
    jne decomment
    jmp badchar                 ; test for end of statement
  ; ===========================
  align 4
  oldc:                         ; old style C split line comments
    mov al, [esi]
    add esi, 1
    test al, al                 ; exit on EOF condition
    je setexit
    cmp al, "*"                 ; test for *
    jne oldc
    cmp BYTE PTR [esi], "/"     ; test if / follows *
    jne oldc
    add esi, 1                  ; correct for look ahead with "/"
    jmp jumpin                  ; read next character
  ; ===========================
  align 4
  deCcomment:                   ; test if C or C++ comment
    test al, al
    je setexit
    cmp BYTE PTR [esi], "/"     ; if next char / cpp comment
    je decomment
    cmp BYTE PTR [esi], "*"     ; if next char * old C comment
    je oldc
    jmp jumpin                  ; if not comment, just continue
  ; ***************************
  ; set next buffer to ZERO
  ; ***************************
  align 4
  setend:
    add lparr, 4                ; set array to next member
    mov edi, lparr              ; load its address in EDI
    mov edi, [edi]              ; dereference it to get start address
    mov BYTE PTR [edi], 0       ; write zero to next buffer
    mov lcflag, 0               ; clear line continuation flag
comment * -----------------------------------------------------------

At this stage the array of string buffers (array) has the arguments
for the current statement loaded sequentially and the following
string buffer has a leading ZERO to determine the end of the arguments.

The argument counter (acnt) contains the number of arguments for
the current statement.

        ----------------------------------------------------------- *

    invoke show_array,array

    cmp eflag, 0
    je reload

  ; ***************************
  zero:

    pop edi
    pop esi
    pop ebx

    ret

source_scanner endp

; 

end start